﻿"use strict";

{
	C3.Plugins.Massive_Cube_Forge.Instance = class ForgeInstance extends C3.SDKInstanceBase
	{
		constructor(inst, properties)
		{
			super( inst );
			this.ky = undefined;
			this.iv = undefined;

			this.kyIsLongEnough = false;
			this.IVIsLongEnough = false;

			this.result = "";

			if (properties)	{	}

			this.cipher = undefined;
			this.decipher = undefined;

			this.encb64 = function(str) {
				return forge.util.encode64(str);
			}

			this.decb64 = function(str) {
				return forge.util.decode64(str);
			}

			this.psrand = function(lng) {
				var bytes = forge.random.getBytesSync(lng);
				return forge.util.bytesToHex(bytes);
			}

			this.sha1 = function(data,_this) {
				var md = forge.md.sha1.create();
				md.update(data);
				return md.digest().toHex();
			}

			this.sha256 = function(data,_this) {
				var md = forge.md.sha256.create();
				md.update(data);
				return md.digest().toHex();
			}

			this.sha384 = function(data,_this) {
				var md = forge.md.sha384.create();
				md.update(data);
				return md.digest().toHex();
			}

			this.sha512 = function(data,_this) {
				var md = forge.md.sha512.create();
				md.update(data);
				return md.digest().toHex();
			}

			this.md5 = function(data,_this) {
				var md = forge.md.md5.create();
				md.update(data);
				return md.digest().toHex();
			}

			this.clKAiV = function(_this) {
				_this.ky = "";
				_this.iv = "";
			}

			this.getTypeIDStr = function(id) {
				switch(id) {
					case 0: return "AES-ECB"; break;
					case 1: return "AES-CBC"; break;
					case 2: return "AES-CFB"; break;
					case 3: return "AES-OFB"; break;
					case 4: return "AES-GCM"; break;
					case 5: return "3DES-ECB"; break;
					case 6: return "3DES-CBC"; break;
					case 7: return "DES-ECB"; break;
					case 8: return "DES-CBC"; break;
					default: return "AES-ECB";
				}
			}


			this.encr = function(type,_this,text) {
				var plaintext = text.toString();  
				var ky = _this.ky;
				var iv = _this.iv;

				var cipher = forge.cipher.createCipher(_this.getTypeIDStr(type), ky);
				cipher.start({iv: iv});
				cipher.update(forge.util.createBuffer(plaintext));
				cipher.finish();
				var encrypted = cipher.output;
				_this.result = forge.util.encode64(encrypted.data);
			}


			this.decr = function(type, _this, text) {
				var plaintext = text.toString();  
				var ky = _this.ky;
				var iv = _this.iv;

				var decodedB64 = forge.util.decode64(plaintext);
				var input = forge.util.createBuffer(decodedB64, 'binary');
				input.getBytes(decodedB64);

				var decipher = forge.cipher.createDecipher(_this.getTypeIDStr(type), ky);
				decipher.start({iv: iv});
				decipher.update(input);
				var result = decipher.finish(); 
				_this.result = decipher.output.data

			}



			this.setky = function( ky, _this ) {
				if((ky.length==16)||(ky.length==24)||(ky.length==32)) {
					_this.ky = ky;
					_this.kyIsLongEnough = true;
				} else {
					_this.kyIsLongEnough = false;
					console.warn("ky is not 16, 24 or 32 chars long!");
				}
			}

			this.setIV = function( iv, _this ) {
				if(iv.length>0) {
					_this.iv = iv;
					_this.IVIsLongEnough = true;
				} else {
					_this.IVIsLongEnough = false;
					_this.iv = "";
					console.warn("iv is not long enough!");
				}
			}

		}
		
		Release() {	super.Release();	}
		SaveToJson() {	return {	};	}
		LoadFromJson(o)	{	}
	};
}